
SuperStrict
Framework BRL.GLMax2D
Import BRL.LinkedList
Import BRL.Random
Import BRL.PNGLoader
Import BRL.StandardIO

SeedRnd(MilliSecs())
Graphics(800,600)
Global currentLevel:Int=1
While currentLevel<6
	TROM.Load(currentLevel)
	TComputer.gameLoop()
Wend

Type TROM
	Function Load(romNr:Int)
		TComputer.programList = New TList
		TComputer.avList = New TList
		TComputer.essentialServiceList = New TList
		Select romNr
			Case 1
				TComputer.device="Hardware Firewall"
				TComputer.goal1="Destroy the firewall software"
				TComputer.goal2=""
				TComputer.goal3=""
				TComputer.maxUserAwarenessShutdown = Rnd(.9,1)
				TComputer.maxUserAwarenessStartAV = Rnd(.7,TComputer.maxUserAwarenessShutdown)
				TComputer.player = TPlayer.Create()
				TComputer.programList.addLast(TComputer.player)
				For Local i:Int = 1 To Rand(3,5)
					Local s:TService = TService.Create()
					TComputer.programList.addLast(s)
					TComputer.essentialServiceList.addLast(s)
				Next
				For Local i:Int = 1 To Rand(5,7)
					TComputer.programList.addLast(TService.Create())
				Next
				For Local i:Int = 1 To Rand(5,7)
					TComputer.programList.addLast(TApp.Create())
				Next
				TComputer.programList.addLast(TAVGuard.Create())
				For Local i:Int = 1 To Rand(2,3)
					TComputer.avList.addLast(TAV.Create())
				Next
				TComputer.programList.addLast(TFireWall.Create(750,300))
				TComputer.remainingKills=1
				TComputer.remainingScans=0
				TComputer.remainingDecodes=0
			Case 2
				TComputer.device="Router"
				TComputer.goal1="Scan all services to find"
				TComputer.goal2="the Routing Tables"
				TComputer.goal3=""
				TComputer.maxUserAwarenessShutdown = Rnd(.9,1)
				TComputer.maxUserAwarenessStartAV = Rnd(.7,TComputer.maxUserAwarenessShutdown)
				TComputer.player = TPlayer.Create()
				TComputer.programList.addLast(TComputer.player)
				Local svcs1:Int=Rand(2,3)
				For Local i:Int = 1 To svcs1
					Local s:TService = TService.Create(1)
					TComputer.programList.addLast(s)
					TComputer.essentialServiceList.addLast(s)
				Next
				Local svcs2:Int=Rand(1,2)
				For Local i:Int = 1 To svcs2
					TComputer.programList.addLast(TService.Create(1))
				Next
				For Local i:Int = 1 To Rand(2,3)
					TComputer.programList.addLast(TApp.Create())
				Next
				TComputer.programList.addLast(TAVGuard.Create(0))
				For Local i:Int = 1 To Rand(5,7)
					TComputer.avList.addLast(TAV.Create())
				Next
				TComputer.remainingKills=0
				TComputer.remainingScans=svcs1+svcs2
				TComputer.remainingDecodes=0
			Case 3
				TComputer.device="Server"
				TComputer.goal1="Find the scannable App"
				TComputer.goal2="Decode it to find the"
				TComputer.goal3="target PC's IP"
				TComputer.maxUserAwarenessShutdown = Rnd(.9,1)
				TComputer.maxUserAwarenessStartAV = Rnd(.7,TComputer.maxUserAwarenessShutdown)
				TComputer.player = TPlayer.Create()
				TComputer.programList.addLast(TComputer.player)
				For Local i:Int = 1 To Rand(3,5)
					Local s:TService = TService.Create()
					TComputer.programList.addLast(s)
					TComputer.essentialServiceList.addLast(s)
				Next
				For Local i:Int = 1 To Rand(7,10)
					TComputer.programList.addLast(TService.Create())
				Next
				For Local i:Int = 1 To Rand(2,3)
					TComputer.programList.addLast(TApp.Create())
				Next
				TComputer.programList.addLast(TApp.Create(1,1))
				TComputer.programList.addLast(TAVGuard.Create())
				For Local i:Int = 1 To Rand(5,7)
					TComputer.avList.addLast(TAV.Create())
				Next
				TComputer.remainingKills=0
				TComputer.remainingScans=1
				TComputer.remainingDecodes=1
			Case 4
				TComputer.device="Target PC"
				TComputer.goal1="Scan and Decode all Apps"
				TComputer.goal2="and Services"
				TComputer.goal3=""
				TComputer.maxUserAwarenessShutdown = Rnd(.9,1)
				TComputer.maxUserAwarenessStartAV = Rnd(.7,TComputer.maxUserAwarenessShutdown)
				TComputer.player = TPlayer.Create()
				TComputer.programList.addLast(TComputer.player)
				Local svcs1:Int = Rand(3,5)
				For Local i:Int = 1 To svcs1
					Local s:TService = TService.Create(1,1)
					TComputer.programList.addLast(s)
					TComputer.essentialServiceList.addLast(s)
				Next
				Local apps:Int = Rand(7,10)
				For Local i:Int = 1 To apps
					TComputer.programList.addLast(TService.Create(1,1))
				Next
				Local svcs2:Int = Rand(5,7)
				For Local i:Int = 1 To svcs2
					TComputer.programList.addLast(TApp.Create(1,1))
				Next
				TComputer.programList.addLast(TAVGuard.Create())
				TComputer.programList.addLast(TAVGuard.Create())
				For Local i:Int = 1 To Rand(5,7)
					TComputer.avList.addLast(TAV.Create())
				Next
				TComputer.remainingKills=0
				TComputer.remainingScans=svcs1+apps+svcs2
				TComputer.remainingDecodes=svcs1+apps+svcs2
			Case 5
				TComputer.device="Target PC"
				TComputer.goal1="Trigger the AVGuard"
				TComputer.goal2="Destroy all AV, AVGuard and Firewall"
				TComputer.goal3=""
				TComputer.maxUserAwarenessShutdown = Rnd(.9,1)
				TComputer.maxUserAwarenessStartAV = Rnd(.7,TComputer.maxUserAwarenessShutdown)
				TComputer.player = TPlayer.Create()
				TComputer.programList.addLast(TComputer.player)
				For Local i:Int = 1 To Rand(3,5)
					Local s:TService = TService.Create()
					TComputer.programList.addLast(s)
					TComputer.essentialServiceList.addLast(s)
				Next
				For Local i:Int = 1 To Rand(7,10)
					TComputer.programList.addLast(TService.Create())
				Next
				For Local i:Int = 1 To Rand(2,3)
					TComputer.programList.addLast(TApp.Create())
				Next
				TComputer.programList.addLast(TApp.Create(1,1))
				TComputer.programList.addLast(TAVGuard.Create())
				Local avs:Int = Rand(5,7)
				For Local i:Int = 1 To avs
					TComputer.avList.addLast(TAV.Create())
				Next
				TComputer.remainingKills=avs+2
				TComputer.remainingScans=0
				TComputer.remainingDecodes=0
				TComputer.programList.addLast(TFireWall.Create(750,300))
		EndSelect
		TComputer.gameRunning=1
	End Function
End Type

Type TComputer Abstract
	Global device:String
	Global goal1:String
	Global goal2:String
	Global goal3:String
	Global totalCP:Float = 2500
	Global polledCP:Float
	Global programList:TList = New TList
	Global player:TPlayer
	Global userAwareness:Float
	Global maxUserAwarenessShutdown:Float
	Global maxUserAwarenessStartAV:Float
	Global essentialServiceList:TList = New TList
	Global avList:TList = New TList
	Global remainingKills:Int
	Global remainingScans:Int
	Global remainingDecodes:Int
	Global gameRunning:Int
	
	Function newFrame()
		polledCP = 0
	End Function
	Function pollAllCP()
		For Local p:TProgram = EachIn programList
			polledCP:+p.drawsCP
		Next
	End Function
	Function getCP:Float(ammount:Float)
		Return Min(ammount*(totalCP/polledCP),ammount)
	End Function
	Function gameLoop()
		SetBlend(Alphablend)
		Cls
		SetColor(0,255,0)
		SetScale(4,4)
		DrawText("VIRUS",100,50)
		SetScale(2,2)
		DrawText("Level "+currentLevel,10,150)
		DrawText("Your location: "+device,10,200)
		DrawText("Your mission:  "+goal1,10,250)
		DrawText("               "+goal2,10,300)
		DrawText("               "+goal3,10,350)
		Delay 500
		SetColor(255,255,255)
		FlushKeys
		Flip
		WaitKey
		SetScale(.5,.5)
		While gameRunning=True
			Cls
			If (KeyHit(KEY_ESCAPE)) Then End
			drawBackground()
			newFrame()
			pollAllCP()
			For Local p:TProgram = EachIn programList
				p.update()
				p.draw()
			Next
			Flip 1
		Wend
	End Function
	Function drawBackground()
		SetScale(1,1)
		DrawText("Total  CP:"+Int(totalCP),5,30)
		DrawText("Polled CP:"+Int(polledCP),5,40)
	End Function
	Function getDistance:Float(x1:Float,y1:Float,x2:Float,y2:Float)
		Return Sqr((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))
	End Function
	Function addUserAwareness(val:Float)
		userAwareness:+val
		If userAwareness>maxUserAwarenessStartAV Then startAV()
		If userAwareness>maxUserAwarenessShutdown Then endRound("Shutdown","The user got suspicious and shut down the computer.")
	End Function
	Function startAV()
		For Local p:TProgram = EachIn avList
			programList.addLast(p)
			avList.remove(p)
		Next
	End Function
	Function endRound(reason:String,subtext:String)
		SetScale(5,5)
		DrawText(reason,200,200)
		SetScale(2,2)
		DrawText(subtext,50,400)
		DrawText("You lost.",270,450)
		SetScale(1,1)
		Flip
		Delay 500
		FlushKeys
		WaitKey
		Cls
		currentLevel:-1
		gameRunning=False
	End Function
	Function winRound()
		SetScale(5,5)
		DrawText("Good Job!",200,200)
		SetScale(2,2)
		DrawText("Get ready for the next round.",200,400)
		SetScale(1,1)
		Flip
		Delay 500
		FlushKeys
		WaitKey
		Cls
		currentLevel:+1
		gameRunning=False
	End Function
	Function addKill()
		remainingKills:-1
		checkWin()
	End Function
	Function addScan()
		remainingScans:-1
		checkWin()
	End Function
	Function addDecode()
		remainingDecodes:-1
		checkWin()
	End Function
	Function checkWin()
		If (remainingKills<=0 And remainingScans<=0 And remainingDecodes<=0) Then winRound()
	End Function
End Type

Type TFunction Abstract
	Method draw(cpAvailable:Float) Abstract
	Method activate() Abstract
End Type

Type TProgram Abstract
	Field gfx:TImage
	Field posX:Float
	Field posY:Float
	Field targetX:Float
	Field targetY:Float
	Field shielded:Int=False
	Field integrity:Double = .999999
	Field functions:TFunction[]=New TFunction[3]
	Field dir:Float=Rand(0,360)
	Field drawsCP:Float
	Field needsScan:Int
	Field needsKill:Int
	Field needsDecode:Int
	Field cr:Int,cg:Int,cb:Int,ca:Float=0
	
	Method init(imageURL:String,x:Float,y:Float)
		gfx = LoadImage(imageURL)
		posX = x
		posY = y
	End Method
	
	Method draw()
		SetScale(.5,.5)
		DrawImage(gfx,posX,posY)
		SetScale(1,1)
		SetColor(cr,cg,cb)
		SetAlpha(ca)
		DrawOval(posX,posY,32,32)
		SetAlpha(1)
		SetColor(255,255,255)
	End Method
	
	'damage: value between 0 and 1
	Method takeDamage(damage:Double)
		integrity=integrity*damage
	End Method
	
	Method moveRandom(speed:Float)
		If ((posX-targetX)^2+(posY-targetY)^2)<100 Then
			targetX=Rand(0,800)
			targetY=Rand(0,600)
		EndIf
		moveTo(speed,.95,targetX,targetY)
	End Method
	Method moveTo(speed:Float,val:Float,x:Float,y:Float)
		If ((posX-x)^2+(posY-y)^2)<4 Then
			Return
		EndIf
		dir = dir*val+ATan2(x-posX,y-posY)*(1-val)
		posX:+Sin(dir)*speed
		posY:+Cos(dir)*speed
		If (posX<-32) Then posX:+832
		If (posX>800) Then posX:-832
		If (posY<-32) Then posY:+632
		If (posY>600) Then posY:-632
	End Method
	
	Method update()
		If (RndDouble()>integrity) Then
			TComputer.programList.addLast(TCrashWarning.Create(Self))
			If (needsKill) Then TComputer.addKill()
		EndIf
	End Method
	
	Method remove()
		TComputer.programList.remove(Self)
	End Method
End Type

Type TCrashWarning Extends TProgram
	Field lifetime:Float
	
	Function Create:TCrashWarning(prog:TProgram)
		Local c:TCrashWarning = New TCrashWarning
		c.init("crash.png",prog.posX,prog.posY)
		c.lifetime = 100.0
		prog.remove()
		Return c
	End Function
	
	Method update()
		lifetime:-1
		If lifetime<0 Then
			TComputer.programList.remove(Self)
		EndIf
	End Method
End Type

Type TService Extends TProgram
	Function Create:TService(needsScan:Int=0,needsDecode:Int=0)
		Local service:TService = New TService
		service.init("service.png",Rand(0,800),Rand(0,600))
		service.drawsCP = Rand(100,300)
		service.targetX=Rand(0,800)
		service.targetY=Rand(0,600)
		service.needsScan=needsScan
		service.needsDecode=needsDecode
		Return service
	End Function
	
	Method update()
		Super.update()
		moveRandom(TComputer.getCP(drawsCP)/drawsCP)
	End Method
	
	Method remove()
		Super.remove()
		TComputer.essentialServiceList.remove(Self)
		TComputer.addUserAwareness(.08)
		If TComputer.essentialServiceList.IsEmpty() Then
			TComputer.endRound("CRASH","You killed some essential system service.")
		EndIf
	End Method
End Type

Type TPlayer Extends TProgram
	Field maxDrawCP:Float = 3000
	Field functions:TFunction[] = New TFunction[5]
	
	Function Create:TPlayer()
		Local player:TPlayer = New TPlayer
		player.init("virus.png", 5, 284);
		player.drawsCP=50
		player.functions[0] = TFuncFreePointer.Create()
		player.functions[1] = TFuncCorruptRAM.Create()
		player.functions[2] = TFuncShield.Create()
		player.functions[3] = TFuncScan.Create()
		player.functions[4] = TFuncDecode.Create()
		player.targetX = player.posX
		player.targetY = player.posY
		Return player
	End Function
	
	Method update()
		If (RndDouble()>integrity) Then
			TComputer.programList.addLast(TCrashWarning.Create(Self))
			TComputer.endRound("You Crashed","Better avoid those AVs next time...")
		EndIf
		
		For Local i:Int = 0 To 4
			If (KeyHit(KEY_1+i)) Then
				functions[i].activate()
			EndIf
		Next
		If MouseHit(MOUSE_RIGHT) Then
			targetX = MouseX()
			targetY = MouseY()
		EndIf
		If KeyDown(KEY_W) Then drawsCP = Min(drawsCP+10,maxDrawCP)
		If KeyDown(KEY_S) Then drawsCP = Max(drawsCP-10,0)
		moveTo((TComputer.getCP(drawsCP)*2.0)/maxDrawCP,0,targetX,targetY)
	End Method
	
	Method draw()
		Super.draw()
		SetScale(1,1)
		SetColor(0,255,0)
		DrawRect(5,5,115,20)
		SetColor(0,0,0)
		DrawRect(5+111.0*(drawsCP/maxDrawCP),7,111-111.0*(drawsCP/maxDrawCP),16)
		SetColor(255,255,255)
		For Local f:TFunction = EachIn functions
			If f<>Null Then
				f.draw(TComputer.getCP(drawsCP))
			EndIf
		Next
	End Method
End Type

Type TApp Extends TProgram
	Function Create:TApp(needsScan:Int=0,needsDecode:Int=0)
		Local app:TApp = New TApp
		app.init("app.png",Rand(0,800),Rand(0,600))
		app.drawsCP = Rand(100,500)
		app.targetX=Rand(0,800)
		app.targetY=Rand(0,600)
		app.needsScan=needsScan
		app.needsDecode=needsDecode
		Return app
	End Function
	
	Method update()
		Super.update()
		moveRandom(TComputer.getCP(drawsCP)/drawsCP)
	End Method
	
	Method remove()
		Super.remove()
		TComputer.addUserAwareness(.2)
	End Method
End Type

Type TFirewall Extends TProgram
	Function Create:TFirewall(x:Int, y:Int)
		Local app:TFirewall = New TFirewall
		app.init("firewall.png",x,y)
		app.drawsCP = Rand(1500,2000)
		app.needsKill=1
		Return app
	End Function
	
	Method update()
		Super.update()
	End Method
	
	Method remove()
		Super.remove()
		TComputer.addUserAwareness(.2)
	End Method
End Type

Type TAV Extends TProgram
	Field attack:TFunction = TFuncFreePointer.Create(1)
	Function Create:TAV()
		Local av:TAV = New TAV
		av.init("av.png",Rand(0,800),Rand(0,600))
		av.drawsCP = Rand(400,1000)
		Return av
	End Function
	
	Method update()
		Super.update()
		moveTo(TComputer.getCP(drawsCP)/drawsCP,0,TComputer.player.posX,TComputer.player.posY)
		If (TComputer.getDistance(posX,posY,TComputer.player.posX,TComputer.player.posY)<100) Then attack.activate()
	End Method
	
	Method draw()
		Super.draw()
		attack.draw(TComputer.getCP(drawsCP))
	End Method
	
	Method remove()
		Super.remove()
		TComputer.addUserAwareness(.2)
	End Method
End Type

Type TAVGuard Extends TProgram
	Function Create:TAVGuard(needsKill:Int=0)
		Local avg:TAVGuard = New TAVGuard
		avg.init("avg.png",Rand(0,800),Rand(0,600))
		While (TComputer.getDistance(avg.posX,avg.posY,TComputer.player.posX,TComputer.player.posY)<300)
			avg.init("avg.png",Rand(0,800),Rand(0,600))
		Wend
		avg.drawsCP = Rand(400,1000)
		avg.needsKill=needsKill
		Return avg
	End Function
	
	Method update()
		Super.update()
		moveRandom(.85*TComputer.getCP(drawsCP)/drawsCP)
		If (TComputer.player.drawsCP>TComputer.player.maxDrawCP/2) Then
			targetX = TComputer.player.posX
			targetY = TComputer.player.posY
		EndIf
		If (TComputer.getDistance(posX,posY,TComputer.player.posX,TComputer.player.posY)<150) Then TComputer.startAV()
	End Method
	
	Method draw()
		Super.draw()
		SetScale(1,1)
		SetColor(0,255,128)
		SetBlend(LIGHTBLEND)
		SetAlpha(.1)
		DrawOval(posX-134,posY-134,300,300)
		SetAlpha(1)
		SetBlend(ALPHABLEND)
		SetColor(255,255,255)
	End Method
	
	Method remove()
		Super.remove()
		TComputer.addUserAwareness(.2)
	End Method
End Type

Type TFuncCorruptRAM Extends TFunction
	Field cooldown:Float
	Field corruptionList:TList = New TList
	
	Function Create:TFuncCorruptRAM()
		Return New TFuncCorruptRAM
	End Function
	
	Method draw(cpAvailable:Float)
		cooldown:-cpAvailable/500
		For Local c:TCorruption = EachIn corruptionList
			If (c.draw()=False) Then
				corruptionList.Remove(c)
			EndIf
		Next
	End Method
	
	Method activate()
		If cooldown<0 Then
			cooldown=60
			For Local i:Int=0 To Rand(2,8)
				corruptionList.addLast(TCorruption.Create())
			Next
			For Local c:TCorruption = EachIn corruptionList
				c.checkVictims()
			Next
		EndIf
	End Method
End Type

Type TCorruption
	Field x:Float,y:Float
	Field duration:Float
	Field damage:Double = .998
	
	Function Create:TCorruption()
		Local c:TCorruption = New TCorruption
		c.x = Rand(0,66)*12
		c.y = Rand(0,50)*12
		c.duration = Rand(100,500)
		Return c
	End Function
	
	Method draw:Int()
		SetColor(255,255,255)
		DrawRect(x,y,12,12)
		duration:-1
		If (duration<0) Then Return False
		Return True
	End Method
	
	Method checkVictims()
		For Local p:TProgram = EachIn TComputer.programList
			If (p.posX-12<x And p.posX+32>x And p.posY-12<y And p.posY+32>y) And (p.shielded=0) Then
				p.takeDamage(damage)
				Print("hit")
			EndIf
		Next
	End Method
End Type

Type TFuncShield Extends TFunction
	Field cooldown:Float
	Field duration:Float
	
	Function Create:TFuncShield()
		Return New TFuncShield
	End Function
	
	Method draw(cpAvailable:Float)
		cooldown:-cpAvailable/500
		If (duration>0) Then
			TComputer.player.shielded = True
			duration:-1
			SetBlend(LIGHTBLEND)
			SetColor(0,64,127)
			SetScale(1,1)
			DrawOval(TComputer.player.posX-16,TComputer.player.posY-16,64,64)
			SetColor(255,255,255)
			SetBlend(ALPHABLEND)
		Else
			TComputer.player.shielded = False
		EndIf
	End Method
	
	Method activate()
		If (cooldown<0) Then
			cooldown = 160
			duration = 40
		EndIf
	End Method
End Type

Type TFuncFreePointer Extends TFunction
	Field controller:Int '0=Player, 1=Enemy
	Field cooldown:Float
	Field range:Float=120
	Field damage:Float=.993
	Field duration:Float
	Field x:Float
	Field y:Float
	
	Function Create:TFuncFreePointer(controller:Int=0)
		Local fp:TFuncFreePointer = New TFuncFreePointer
		fp.controller = controller
		Return fp
	End Function
	
	Method draw(cpAvailable:Float)
		SetScale(1,1)
		cooldown:-cpAvailable/500
		If (duration>0) Then
			duration:-1
			Local coordarr:Float[] = New Float[Rand(4,8)*2]
			For Local i:Int = 0 To coordarr.length-1 Step 2
				coordarr[i] = x+Rand(0,32)
				coordarr[i+1] = y+Rand(0,32)
			Next
			DrawPoly(coordarr)
		EndIf
	End Method
	
	Method activate()
		Local player:TPlayer = TComputer.player
		Local tx:Int,ty:Int
		If (controller=1) Then
			tx = player.posX+16
			ty = player.posY+16
		Else
			tx = MouseX()
			ty = MouseY()
		EndIf
		If (cooldown<0 And TComputer.getDistance(player.posX,player.posY,tx,ty)<range) And (player.shielded=0) Then
			cooldown = 160
			duration = 30
			x = tx-16
			y = ty-16
			For Local p:TProgram = EachIn TComputer.programList
				If (p.posX-16<x And p.posX+32>x And p.posY-16<y And p.posY+32>y) And (p.shielded=0) Then
					p.takeDamage(damage)
				EndIf
			Next
		EndIf
	End Method
End Type

Type TFuncScan Extends TFunction
	Field cooldown:Float
	Field duration:Float
	Field x:Float,y:Float
	Field range:Float=100
	
	Function Create:TFuncScan()
		Return New TFuncScan
	End Function
	
	Method draw(cpAvailable:Float)
		cooldown:-cpAvailable/500
		If (duration>0) Then
			duration:-1
			SetBlend(LIGHTBLEND)
			SetColor(0,255,0)
			SetScale(1,1)
			SetAlpha(duration/30)
			DrawOval(x,y,64,64)
			SetAlpha(1)
			SetColor(255,255,255)
			SetBlend(ALPHABLEND)
		EndIf
	End Method
	
	Method activate()
		Local player:TPlayer = TComputer.player
		If (cooldown<0 And TComputer.getDistance(player.posX,player.posY,MouseX(),MouseY())<range) And (player.shielded=0) Then
			cooldown = 160
			duration = 30
			x = MouseX()-16
			y = MouseY()-16
			For Local p:TProgram = EachIn TComputer.programList
				If (p.posX-16<x And p.posX+32>x And p.posY-16<y And p.posY+32>y) And (p.shielded=0) Then
					If (p.needsScan) Then
						p.needsScan=0
						p.cg=255
						p.ca=.2
						TComputer.addScan()
					EndIf
				EndIf
			Next
		EndIf
	End Method
End Type

Type TFuncDecode Extends TFunction
	Field cooldown:Float
	Field duration:Float
	Field x:Float,y:Float
	Field range:Float=100
	
	Function Create:TFuncDecode()
		Return New TFuncDecode
	End Function
	
	Method draw(cpAvailable:Float)
		cooldown:-cpAvailable/500
		If (duration>0) Then
			duration:-1
			SetBlend(LIGHTBLEND)
			SetColor(0,0,255)
			SetScale(1,1)
			SetAlpha(duration/30)
			DrawOval(x,y,64,64)
			SetAlpha(1)
			SetColor(255,255,255)
			SetBlend(ALPHABLEND)
		EndIf
	End Method
	
	Method activate()
		Local player:TPlayer = TComputer.player
		If (cooldown<0 And TComputer.getDistance(player.posX,player.posY,MouseX(),MouseY())<range) And (player.shielded=0) Then
			cooldown = 160
			duration = 30
			x = MouseX()-16
			y = MouseY()-16
			For Local p:TProgram = EachIn TComputer.programList
				If (p.posX-16<x And p.posX+32>x And p.posY-16<y And p.posY+32>y) And (p.shielded=0) Then
					If (p.needsDecode) Then
						p.needsDecode=0
						p.cb=255
						p.ca=.2
						TComputer.addDecode()
					EndIf
				EndIf
			Next
		EndIf
	End Method
End Type